View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.statemachine.transition;
    21
    22  import org.apache.mina.statemachine.State;
    23  import org.apache.mina.statemachine.StateMachine;
    24  import org.apache.mina.statemachine.event.Event;
    25
    26  /**
    27   * The interface implemented by classes which need to react on transitions
    28   * between states.
    29   *
    30   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    31   */
    32  public interface Transition {
    33      /**
    34       * Executes this {@link Transition}. It is the responsibility of this
    35       * {@link Transition} to determine whether it actually applies for the
    36       * specified {@link Event}. If this {@link Transition} doesn't apply
    37       * nothing should be executed and <code>false</code> must be returned.
    38       *
    39       * @param event the current {@link Event}.
    40       * @return <code>true</code> if the {@link Transition} was executed,
    41       *         <code>false</code> otherwise.
    42       */
    43      boolean execute(Event event);
    44
    45      /**
    46       * Returns the {@link State} which the {@link StateMachine} should move to
    47       * if this {@link Transition} is taken and {@link #execute(Event)} returns
    48       * <code>true</code>.
    49       *
    50       * @return the next {@link State} or <code>null</code> if this
    51       *         {@link Transition} is a loopback {@link Transition}.
    52       */
    53      State getNextState();
    54  }